#define STRICT
#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include "resource.h"
#include "afxres.h"
#include "somebook.h"

// Корневой элемент дерева
char szBooks[]      = "Книги издательства АО 'Диалог-МИФИ'";

// Вложенные элементы первого уровня
char szBSPSeries[]  = "Библиотека системного программиста, "
  "(C) Фролов А.В., Фролов Г.В., 1991-1995 г.";

char szStepSeries[] = "Персональный компьютер. Шаг за шагом, "
  "(C) Фролов А.В., Фролов Г.В., 1994-1995 г.";

typedef struct tagBOOKINFO
{
  char szBookName[256];
  UINT nVolumeNumber;
} BOOKINFO;

// Вложенные элементы второго уровня
BOOKINFO rgSPLBookInfo[]=
{
  {"Microsoft Windows 3.1 для программиста", 11},
  {"Графический интерфейс GDI в Microsoft Windows ", 14},
};

BOOKINFO rgStepBookInfo[]=
{
  {"Операционная система Microsoft Windows. "
    "Руководство пользователя", 2},
  {"Локальные сети персональных компьютеров", 3},
};

// Номера изображений для органа управления Tree View
int idxBooks, idxBookClosed, idxBookOpened;

HINSTANCE hInst;
char szAppName[]  = "SomeBookApp";
char szAppTitle[] = "Some programmer and user books";
HWND hwndTree;

// -----------------------------------------------------
// Функция WinMain
// -----------------------------------------------------
int APIENTRY 
WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
        LPSTR lpCmdLine, int nCmdShow)
{
  WNDCLASSEX wc;
  HWND hWnd;
  MSG msg;
  
  hInst = hInstance;

  // Преверяем, не было ли это приложение запущено ранее
  hWnd = FindWindow(szAppName, NULL);
  if(hWnd)
  {
    if(IsIconic(hWnd))
	  ShowWindow(hWnd, SW_RESTORE);
	SetForegroundWindow(hWnd);
    return FALSE;
  }

  // Регистрируем класс окна
  memset(&wc, 0, sizeof(wc));
  wc.cbSize = sizeof(WNDCLASSEX);
  wc.hIconSm = LoadImage(hInst,
    MAKEINTRESOURCE(IDI_APPICONSM), IMAGE_ICON, 16, 16, 0);
  wc.style = 0;
  wc.lpfnWndProc = (WNDPROC)WndProc;
  wc.cbClsExtra  = 0;
  wc.cbWndExtra  = 0;
  wc.hInstance = hInst;
  wc.hIcon = LoadImage(hInst,
    MAKEINTRESOURCE(IDI_APPICON), IMAGE_ICON, 32, 32, 0);
  wc.hCursor = LoadCursor(NULL, IDC_ARROW);
  wc.hbrBackground = (HBRUSH) (COLOR_WINDOW + 1);
  wc.lpszMenuName = MAKEINTRESOURCE(IDR_APPMENU);
  wc.lpszClassName = szAppName;
  if(!RegisterClassEx(&wc))
    if(!RegisterClass((LPWNDCLASS)&wc.style))
	  return FALSE;
    
  // Создаем главное окно приложения
  hWnd = CreateWindow(szAppName, szAppTitle, WS_OVERLAPPEDWINDOW,
   	 CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInst, NULL);
  if(!hWnd) return(FALSE);

  // Отображаем окно и запускаем цикл обработки сообщений
  ShowWindow(hWnd, nCmdShow);
  UpdateWindow(hWnd);
  while(GetMessage(&msg, NULL, 0, 0))
  {
    TranslateMessage(&msg);
    DispatchMessage(&msg);
  }
  return msg.wParam;
}

// -----------------------------------------------------
// Функция WndProc
// -----------------------------------------------------
LRESULT WINAPI
WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
  switch(msg)
  {
    HANDLE_MSG(hWnd, WM_CREATE,     WndProc_OnCreate);
    HANDLE_MSG(hWnd, WM_DESTROY,    WndProc_OnDestroy);
    HANDLE_MSG(hWnd, WM_COMMAND,    WndProc_OnCommand);
    HANDLE_MSG(hWnd, WM_SIZE,       WndProc_OnSize);

	default:
      return(DefWindowProc(hWnd, msg, wParam, lParam));
  }
}

// -----------------------------------------------------
// Функция WndProc_OnCreate
// -----------------------------------------------------
BOOL WndProc_OnCreate(HWND hWnd, LPCREATESTRUCT lpCreateStruct)
{
  RECT rc;
  HIMAGELIST himl;
  HBITMAP hBmp;
  HTREEITEM hRootItem;
  HTREEITEM hBSPItem;
  HTREEITEM hStepItem;

  // Определяем размеры внутренней области главного окна
  GetClientRect(hWnd, &rc);

  // Инициализируем библиотеку стандартных органов управления
  InitCommonControls();

  // Создаем орган управления Tree View
  hwndTree = CreateWindowEx(0L, WC_TREEVIEW, "",
    WS_VISIBLE | WS_CHILD | WS_BORDER |
    TVS_HASLINES | TVS_HASBUTTONS | TVS_LINESATROOT,
    0, 0, rc.right - rc.left, rc.bottom - rc.top,
    hWnd, (HMENU) IDC_TREEVIEW, hInst, NULL);

  if(hwndTree == NULL)
    return FALSE;

  // Создаем список изображений
  himl = ImageList_Create(33, 33, FALSE, 3, 0);

  // Добавляем изображения в список
  hBmp = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_BOOKS));
  idxBooks = ImageList_Add(himl, hBmp, NULL);

  hBmp = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_BOOK_CLOSED));
  idxBookClosed = ImageList_Add(himl, hBmp, NULL);

  hBmp = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_BOOK_OPENED));
  idxBookOpened = ImageList_Add(himl, hBmp, NULL);

  // Добавляем список изображений
  TreeView_SetImageList(hwndTree, himl, TVSIL_NORMAL);

  // Вставляем корневой элемент
  hRootItem = InsTreeItem((HTREEITEM)TVI_ROOT, szBooks, 
    (HTREEITEM)TVI_FIRST, idxBooks, idxBooks);

  // Вставляем вложенные элементы первого уровня
  hBSPItem = InsTreeItem(hRootItem, szBSPSeries, 
    (HTREEITEM)TVI_SORT, idxBooks, idxBooks);

  hStepItem = InsTreeItem(hRootItem, szStepSeries, 
    (HTREEITEM)TVI_SORT, idxBooks, idxBooks);

  // Вставляем вложенные элементы второго уровня
  InsTreeItem(hBSPItem, rgSPLBookInfo[0].szBookName, 
    (HTREEITEM)TVI_SORT, idxBookClosed, idxBookOpened);

  InsTreeItem(hBSPItem, rgSPLBookInfo[1].szBookName, 
    (HTREEITEM)TVI_SORT, idxBookClosed, idxBookOpened);

  InsTreeItem(hStepItem, rgStepBookInfo[0].szBookName, 
    (HTREEITEM)TVI_SORT, idxBookClosed, idxBookOpened);

  InsTreeItem(hStepItem, rgStepBookInfo[1].szBookName, 
    (HTREEITEM)TVI_SORT, idxBookClosed, idxBookOpened);

  return TRUE;
}

// -----------------------------------------------------
// Функция InsTreeItem
// -----------------------------------------------------
HTREEITEM InsTreeItem(HTREEITEM hParent, LPSTR szText, 
  HTREEITEM hAfter, int iImage, int iSelectedImage)
{
  TV_INSERTSTRUCT tvins;
  HTREEITEM hItem;

  memset(&tvins, 0, sizeof(tvins));

  tvins.item.mask = TVIF_TEXT | TVIF_IMAGE | 
     TVIF_SELECTEDIMAGE | TVIF_PARAM;
  tvins.item.pszText = szText;
  tvins.item.cchTextMax = lstrlen(szText);
  tvins.item.iImage = iImage;
  tvins.item.iSelectedImage = iSelectedImage;

  tvins.hInsertAfter = hAfter;
  tvins.hParent = hParent;
  
  hItem = TreeView_InsertItem(hwndTree, &tvins); 
  return hItem;
}

// -----------------------------------------------------
// Функция WndProc_OnDestroy
// -----------------------------------------------------
#pragma warning(disable: 4098)
void WndProc_OnDestroy(HWND hWnd)
{
  DestroyWindow(hwndTree);
  PostQuitMessage(0);
  return 0L;
}

// -----------------------------------------------------
// Функция WndProc_OnCommand
// -----------------------------------------------------
#pragma warning(disable: 4098)
void WndProc_OnCommand(HWND hWnd, int id, 
  HWND hwndCtl, UINT codeNotify)
{
  DWORD dwStyle = 0;

  switch (id)
  {
	case ID_FILE_EXIT:
	  PostQuitMessage(0);
	  return 0L;
	  break;
	  
  	case ID_HELP_ABOUT:
	  break;

  	default:
	  break;
  }
  return FORWARD_WM_COMMAND(hWnd, id, hwndCtl, codeNotify,
    DefWindowProc);
}

// -----------------------------------------------------
// Функция WndProc_OnSize       
// -----------------------------------------------------
#pragma warning(disable: 4098)
void WndProc_OnSize(HWND hwnd, UINT state, int cx, int cy)
{
  MoveWindow(hwndTree, 0, 0, cx, cy, TRUE);
  return FORWARD_WM_SIZE(hwnd, state, cx, cy, DefWindowProc);
}

